import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.XMLFilterImpl;

/**
 * @author Patryk Czarnik
 *
 */
public class FiltrySAX {

  public static void main(String[] args) {
    try {
      SAXParserFactory parser_fact = SAXParserFactory.newInstance();
      XMLReader reader = parser_fact.newSAXParser().getXMLReader();
      
      MojFiltr filtr = new MojFiltr();
      
      InfoHandler handler = new InfoHandler();
      filtr.setParent(reader);
      filtr.setContentHandler(handler);
      filtr.parse(args[0]);
    } catch(Exception e) {
      e.printStackTrace();
    }
  }

  private static class MojFiltr extends XMLFilterImpl {

    /**Przepuszcza niepuste wezly tekstowe.
     * @see org.xml.sax.helpers.XMLFilterImpl#characters(char[], int, int)
     */
    @Override
    public void characters(char[] aCh, int aStart, int aLength) throws SAXException {
      if(this.getContentHandler() != null && aLength > 0)
        this.getContentHandler().characters(aCh, aStart, aLength);
    }

    /**Zmienia nazwy elementow na pisane duzymi literami.
     * @see org.xml.sax.helpers.XMLFilterImpl#endElement(java.lang.String, java.lang.String, java.lang.String)
     */
    @Override
    public void endElement(String aUri, String aLocalName, String aName) throws SAXException {
      if(this.getContentHandler() != null)
        this.getContentHandler().endElement(aUri, aLocalName.toUpperCase(), aName.toUpperCase());
    }

    /**Zmienia nazwy elementow na pisane duzymi literami.
     * @see org.xml.sax.helpers.XMLFilterImpl#startElement(java.lang.String, java.lang.String, java.lang.String, org.xml.sax.Attributes)
     */
    @Override
    public void startElement(String aUri, String aLocalName, String aName, Attributes atts) throws SAXException {
      if(this.getContentHandler() != null)
        this.getContentHandler().startElement(aUri, aLocalName.toUpperCase(), aName.toUpperCase(), atts);
    }
  }
}
